=== debian/changelog ===
ldc (1:0.17.0~beta2-1) unstable; urgency=medium

  * New upstream release, make it linux-any.

 -- Konstantinos Margaritis <markos@debian.org>  Sun, 31 Jan 2016 15:07:35 +0200

ldc (1:0.15.1-2) experimental; urgency=medium

  * Updated debian/copyright to better reflect current licensing.

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 16 Dec 2014 15:14:00 +0200

ldc (1:0.15.1-1) experimental; urgency=medium

  * New upstream release, added PowerPC architectures (powerpc, ppc64, ppc64le).
    (Closes: #754690)
  * Add lintian-overrides for libphobos2-ldc-debug66 in order to make it
   lintian clean.
  * Changed Recommends: libphobos2-ldc-dev to Depends, otherwise
   apt fails to download it.

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 15 Oct 2014 18:52:04 +0300
